H5W3
当前位置:H5W3 > python > 正文

【Python】为什么这段代码没有异常抛出?

In [8]: def bar():
...:     a = 10
...:     try:
...:         raise
...:     except:
...:         try:
...:             raise
...:         except:
...:             raise
...:     finally:
...:         return a
In [9]: bar()
Out[9]: 10

回答

这个还挺有意思的,首先跑几个代码

1. 这段代码表示你不要管套几层try,其实只要弄清楚except下为什么不抛出异常即刻
def bar():
    a = 10
    try:
        print 1
        raise
    except:
        print 2
        raise
    finally:
        print 3
        return a

bar()
# 打印(没有抛出异常): 
# 2
# 3
2. 这段代码表示如果finally如果有return语句,则不会抛出异常,没有return则会抛出异常
def bar():
    a = 10
    try:
        print 1
        raise
    except:
        print 2
        raise
    finally:
        print 3
        # return a
bar()
# 打印(抛出了异常):
# 2
# Traceback (most recent call last):
# 3
#   File "/Users/xuxin/workplace/DailyScript/segmentfault/file_list_to_dict.py", line 23, in <module>
#     bar()
#   File "/Users/xuxin/workplace/DailyScript/segmentfault/file_list_to_dict.py", line 18, in bar
#     raise ValueError()
# ValueError
3. 我去查了一下,看到了这篇文章深入理解Python的finally

看来f()在抛出异常并后,执行了except中的return,但是并没有返回到调用者,而是“坚持”将finally中的代码执行完毕。至此,我算是真正理解了finally的真正含义,就是即使已经return,仍要执行finally中的代码。

这里我们同样可以这么理解,在try中如果出现了需要退出方法的语句,但他会努力执行finally,如果finally有return方法,则会立即返回,不会执行之前的退出语句。
这个时候,我们可以看看这串代码

def bar():
    a = 10
    try:
        print 1
        raise
    finally:
        print 3
        return a

bar()
# 打印(没有抛出异常): 
# 3
4.这个时候是不是对finally比较清楚了呢~

现学现卖,如有错误,请指出修改~

要是最后还是抛出了异常,那你的except语句不是白写了?

本文地址:H5W3 » 【Python】为什么这段代码没有异常抛出?

评论 0

  • 昵称 (必填)
  • 邮箱 (必填)
  • 网址